package CalculiX;

public abstract class Expression {

  // An expression can be evaluated, to produce a value.

  // Evaluation requires an environment. The environment maps variables to
  // values. The environment should contain an entry for each of the variables
  // that appear free in the expression.

  // Evaluation can fail. In that case, an EvalException exception is thrown.

  public abstract Value eval (Environment env) throws EvalException;

}

